#include <SPI.h>
#include <SD.h>

#define adrsdat 5
#define adrsclk 7
#define adrslat 23 //pin PC7
#define srOE 20 //shared ram /OE pin PC4
#define srRW 19 //shared ram R/W pin PC3
#define srCE 18 //shared ram /CE pin PC2
#define sdCS 4

const byte z80loaderbin[] PROGMEM = { 0xED, 0x73, 0x04, 0x33, 0x31, 0x20, 0x33, 0x3A, 0x00, 0x33, 0xD6, 0x00, 0x28, 0x55, 0x3A, 0x00, 0x33, 0xD6, 0x02, 0x28, 0x1E, 0x3A, 0x00, 0x33, 0xD6, 0x03, 0x28, 0x24, 0x3A, 0x00, 0x33, 0xD6, 0x04, 0x28, 0x2A, 0xC3, 0x07, 0x30, 0x3E, 0x01, 0x32, 0x00, 0x33, 0x3A, 0x00, 0x33, 0xD6, 0x01, 0xC8, 0x18, 0xF3, 0xED, 0x5B, 0x02, 0x33, 0x1A, 0x32, 0x01, 0x33, 0xCD, 0x26, 0x30, 0x18, 0xC7, 0xED, 0x5B, 0x02, 0x33, 0x3A, 0x01, 0x33, 0x12, 0xCD, 0x26, 0x30, 0x18, 0xBA, 0x2A, 0x02, 0x33, 0x3E, 0x00, 0x32, 0x00, 0x33, 0x3A, 0x00, 0x33, 0xD6, 0x00, 0x28, 0x02, 0x18, 0xEF, 0xED, 0x7B, 0x04, 0x33, 0xE9, 0x3A, 0x06, 0x33, 0xD6, 0x00, 0x28, 0x13, 0x57, 0x3E, 0x00, 0x32, 0x06, 0x33, 0x3A, 0x06, 0x33, 0xD6, 0x00, 0x20, 0xF4, 0xED, 0x7B, 0x04, 0x33, 0x7A, 0xC9, 0xED, 0x7B, 0x04, 0x33, 0x11, 0x15, 0x40, 0xC3, 0x13, 0x00 };

bool resetsw=0;

unsigned int rsStart = 0x4000;
unsigned int rsEnd   = 0x7fff;

void setup(){
  Serial.begin(57600);
  DDRA = 0x00; PORTA = 0xff; //set data bus to input pullup
  pinMode(adrslat, OUTPUT); //setup adress bus shift registers
  SPI.begin();
  digitalWrite(srCE,1); pinMode(srCE, OUTPUT); //setup ram control pins
  digitalWrite(srOE,1); pinMode(srOE, OUTPUT); 
  digitalWrite(srRW,1); pinMode(srRW, OUTPUT);
  pinMode(1, INPUT_PULLUP);
  //localzero(); loadz80loader();
  
  if(!SD.begin(sdCS)){
    Serial.println("SD card not found.");
    return;
  }
  pinMode(0,OUTPUT);
  digitalWrite(0,1); 
  Serial.println(F("OK"));
  Serial.print(F(">"));
  
}

void loop(){
  serialControl();
  if(resetsw==0&&digitalRead(1)==0){
    resetsw=1;
    digitalWrite(0,0);
    localzero(); loadz80loader();
    digitalWrite(0,1);
    Serial.println();
    Serial.println(F("TRS-80 Reset"));
  }
  if(resetsw==1&&digitalRead(1)==1){
    resetsw=0;
  }
}
